<!DOCTYPE rkplugin>
<document>
	<code file="recode_categorical.js" />
	<help file="recode_categorical.rkh" />
	<logic>
		<connect governor="x.available" client="set.contents.levels.variable"/>
		<connect governor="datamode.string" client="set.contents.new_value_custom.datatype"/>
		
		<convert id="saveto_other_object" mode="equals" sources="saveto_select.string" standard="other"/>
		<connect governor="saveto_other_object" client="saveto.enabled"/>

		<convert id="other_values_custom" mode="equals" sources="other.string" standard="custom"/>
		<connect governor="other_values_custom" client="other_custom.enabled"/>

		<script><![CDATA[
			gui.addChangeCommand ("datamode", "update ()");

			update = function () {
				var mode = gui.getValue ("datamode.string");
				gui.setValue ("set.contents.quotation_note.visible", mode == "factor" || mode == "character");
			}
		]]></script>
	</logic>
	<dialog label="Recode categorical data"><tabbook>
		<tab label="Input and output variables" id="tab_in_out">
			<varselector id="vars"/>
			<varslot id="x" source="vars" label="Select variable to recode" num_dimensions="1" required="true"/>
			<row>
				<radio id="saveto_select" label="Save to">
					<option value="same" label="Same object"/>
					<option value="other" label="Other:" checked="true"/>
				</radio>
				<saveobject id="saveto" label="Object to save to" initial="recoded"/>
			</row>
			<dropdown id="datamode" label="Data type after recoding">
				<option value="character" label="Character"/>
				<option value="factor" label="Factor" checked="true"/>
				<option value="numeric" label="Numeric"/>
				<option value="logical" label="Logical"/>
			</dropdown>
			<stretch/>
			<preview id="preview" label="Preview" mode="data"/>
		</tab>
		<tab label="Values" id="tab_values">
				<column>
					<optionset id="set" min_rows="1" label="Recodings">
						<logic>
							<convert id="old_value_na" mode="equals" sources="old_value_type.string" standard="na"/>
							<connect client="levels.enabled" governor="old_value_na.not"/>
							<connect client="values.enabled" governor="old_value_na.not"/>

							<convert id="new_value_na" mode="equals" sources="new_value.string" standard="na"/>
							<connect client="new_value_custom.enabled" governor="new_value_na.not"/>

							<!-- The purpose of these switch-properties is to provide readable labels for NA / value -->
							<switch condition="old_value_na" id="old_value_string">
								<true fixed_value="NA" />
								<false dynamic_value="values.available" />
							</switch>
							<switch condition="new_value_na" id="new_value_string">
								<true standard="na" fixed_value="_NA_" />
								<false dynamic_value="new_value_custom.valuequoted" />
							</switch>
						</logic>
						<optioncolumn id="old_values_labelled" connect="old_value_string" label="Old value(s)"/>
						<optioncolumn id="old_value_types" connect="old_value_type.string"/>
						<optioncolumn id="old_value_strings" connect="values.available"/>

						<optioncolumn id="new_values_labelled" connect="new_value_string" label="New value(s)"/>
						<optioncolumn id="new_value_types" connect="new_value.string"/>
						<optioncolumn id="new_value_strings" connect="new_value_custom.value"/>
						<content>
							<frame>
								<optiondisplay index="true"/>
								<row>
									<column>
										<radio id="old_value_type" label="Old values">
											<option value="na" label="NA"/>
											<option value="value" label="Select value(s):" checked="true"/>
										</radio>
										<row>
											<embed id="levels" component="rkward::level_select"/>
											<valueslot multi="true" required="true" min_vars="1" id="values" label="" source="levels.selector"/>
										</row>
									</column>
									<column>
										<radio id="new_value" label="New value">
											<option value="na" label="NA"/>
											<option value="custom" label="Value:" checked="true"/>
										</radio>
										<embed id="new_value_custom" component="rkward::multi_input"/>
										<text id="quotation_note" type="normal">(Value will be quoted, automatically)</text>
										<stretch/>
									</column>
								</row>
							</frame>
						</content>
					</optionset>
			<radio id="other" label="Any other values">	<!-- TODO Should this be including original NAs? -->
				<option value="copy" label="Copy" id="copy_others"/>
				<option value="na" label="NA"/>
				<option value="custom" label="Custom value:"/>
			</radio>
			<embed id="other_custom" component="rkward::multi_input"/>
				</column>
		</tab>
	</tabbook></dialog>
</document>
